<!DOCTYPE html>
<html lang="en">
  <head>
    <%- include('../_meta.ejs') %>
    <title><%= locals.project %> · <%- title %></title>
    <%- include('../_favicon.ejs') %>
    <%- include('../_bootstrap.ejs') %>
    <link rel="stylesheet" href="<%- locals.host %>/css/login.css" />
    <link rel="stylesheet" href="<%- locals.host %>/lib/font-awesome/css/all.min.css" />
  </head>
  <body class="text-center">
    <main class="form-signin w-100 m-auto">
      <form autocomplete="off" action="<%- locals.host %>/oidc/_tldr/<%= uid %>/confirm" method="post">
        <img class="mb-4" src="<%- locals.host %>/asset/image/company-logo.svg" alt="" width="72" height="57" />
        <% if (client.logoUri) { %>
        <span class="mr-10 ml-10"><i class="fa fa-exchange"></i></span>
        <img class="mb-4" src="<%- locals.host %>/asset/image/company-logo.svg" alt="" width="72" height="57" />
        <% } %>

        <h1 class="h3 mb-3 fw-normal"><strong><%- title %></strong></h1>

        <div class="authorize-box text-left mt-3 mb-3 p-2">
          <% if ([details.missingOIDCScope, details.missingOIDCClaims, details.missingResourceScopes].filter(Boolean).length === 0) { %>
            <div class="mt-2">The client is asking you to confirm previously given authorization</div>
          <% } %>
          
          <% missingOIDCScope = new Set(details.missingOIDCScope); missingOIDCScope.delete('openid'); %>
          <% missingOIDCScope.delete('offline_access') %>
          <% if (missingOIDCScope.size) { %>
            <div>The client is asking to access your <strong>scopes</strong>:</div>
            <ul>
            <% missingOIDCScope.forEach((scope) => { %>
              <li><%= scope %></li>
            <% }) %>
            </ul>
          <% } %>
          
          <% missingOIDCClaims = new Set(details.missingOIDCClaims); %>
          <% ['sub', 'sid', 'auth_time', 'acr', 'amr', 'iss'].forEach(Set.prototype.delete.bind(missingOIDCClaims)) %>
          
          <% if (missingOIDCClaims.size) { %>
            <div>Claims:</div>
            <ul>
            <% missingOIDCClaims.forEach((claim) => { %>
              <li><%= claim %></li>
            <% }) %>
            </ul>
          <% } %>
          
          <% missingResourceScopes = details.missingResourceScopes %>
          <% if (missingResourceScopes) { %>
            <% for (const [indicator, scopes] of Object.entries(details.missingResourceScopes)) { %>
              <div>
                The client ask to get access your resource from
                <a href="<%= indicator %>"><%= indicator %></a>
                regarding <strong>scopes</strong>:
              </div>
              <ul>
                <% scopes.forEach((scope) => { %>
                  <li><%= scope %></li>
                <% }) %>
              </ul>
            <% } %>
          <% } %>
          
          <% if (params.scope && params.scope.includes('offline_access')) { %>
            <div class="mt-2">
              <p>
                The client is asking to have <em>offline_access</em>
                with <strong><%= locals.project %></strong> authorization
                <% if ((!details.missingOIDCScope) || !details.missingOIDCScope.includes('offline_access')) { %>
                  <br><small>.. Which you've previously granted</small>
                <% } %>
              </p>
            </div>
          <% } %>
        </div>

        <button autofocus class="w-100 btn btn-lg btn-primary" type="submit">Continue</button>
      </form>
      <%- include('./_login-helper.ejs') %>
      <%- include('./_debug.ejs') %>
      <p class="mt-5 mb-3 text-body-secondary">&copy; 2017–2023</p>
    </main>
  </body>
</html>
